using System;
namespace id.Quake.Files {

	public partial class Level {

		/// <summary>Calculates the intersection point between a start position, end position, and the world.</summary>
		/// <param name="start">The position to start from.</param>
		/// <param name="end">The position to try to end at.</param>
		/// <returns>Information about the collision.</returns>
		public CollisionResult<Vector3> GetCollision(Vector3 start, Vector3 end) {
			CollisionResult<Vector3> Result = new CollisionResult<Vector3>(false, end);
			foreach (Model m in this.models) {
				CollisionResult<Vector3> C = m.GetCollision(start, Result.Position);
				if (C.CollisionOccured) {
					Result.Model = m;
					Result = C;
				}
			}
			return Result;
		}
	}
}
